#ifndef SPCT6100_H
#define SPCT6100_H

#include <poll.h>
#include "spct6100-types.h"

extern char *
spct6100_sdk_version( void );

extern int
spct6100_open_device( const char *device_name );

extern int
spct6100_close_device( int fd );

extern int
spct6100_init_dsp( int fd, const char *data_file, const char *inst_file );

extern int
spct6100_init_system( int fd, const char *data_file, const char *inst_file, const char *isr_inst_file );

extern int
spct6100_set_property( int fd, struct spct6100_property *p );

extern int
spct6100_get_property( int fd, struct spct6100_property *p );

extern int
spct6100_system_start( int fd );

extern int
spct6100_system_stop( int fd );

extern void *
spct6100_mmap( int fd );

extern int
spct6100_munmap( void *mmap_addr );

extern int
spct6100_streamon( int fd );

extern int
spct6100_streamoff( int fd );

extern int
spct6100_poll( struct pollfd *fds, nfds_t nfds, int timeout );

extern int
spct6100_get_data( int fd, void *mmap_addr, struct spct6100_buffer *pdata );

extern int
spct6100_free_data( int fd );

#endif /* SPCT6100_H */
