#!/bin/sh

show_help(){
cat << EOF
Usage: $0 [OPTIONS]

OPTIONS:
  -h, --help            display this help and exit
  -r address            set driver reserved address
EOF
exit 0
} #show_help()

RESERV_ADDR=
while [ $# -ne 0 ]; do
  case $1 in
  -h|--help)
    show_help
    ;;
  -r)
    shift
    RESERV_ADDR=$1;
  esac
  shift
done

_tmp_path=`dirname $0`
CURRENT_PATH=`cd ${_tmp_path}; pwd`

## V4L2 driver
rmmod spct6100.ko &>/dev/null

cd ${CURRENT_PATH}/driver

if [ -z ${RESERV_ADDR} ]; then
  ./unload_pacdmp &>/dev/null
  echo "./load_pacdmp"
  sleep 1
  ./load_pacdmp
else
  ./unload_pacdmp &>/dev/null
  echo "./load_pacdmp pacdmp_reserved_addr=${RESERV_ADDR}"
  sleep 1
  ./load_pacdmp pacdmp_reserved_addr=${RESERV_ADDR}
fi
