#ifndef VO_SDL_H
#define VO_SDL_H

#define SPCT_YV12_FORMAT  0x32315659    /* Planar mode: Y + V + U  (3 planes) */
#define SPCT_IYUV_FORMAT  0x56555949    /* Planar mode: Y + U + V  (3 planes) */
#define SPCT_YUY2_FORMAT  0x32595559    /* Packed mode: Y0+U0+Y1+V0 (1 plane) */
#define SPCT_UYVY_FORMAT  0x59565955    /* Packed mode: U0+Y0+V0+Y1 (1 plane) */
#define SPCT_YVYU_FORMAT  0x55595659    /* Packed mode: Y0+V0+Y1+U0 (1 plane) */

typedef struct tagDisplay_Rect {
	int x;
	int y;
	int w;
	int h;
} Display_Rect;

extern int
vo_init (int width, int height, int channel_num, const char *title);

extern int
vo_clean ();

extern int
vo_show_picture (int channel, void *data, int src_w, int src_h,
                 unsigned int format, Display_Rect *rect);

extern int
vo_resize (int width, int height);

extern int
vo_draw_rect_uyvy (int channel, void *data, int src_w, int src_h,
                   unsigned int format, int x, int y,
                   unsigned int w, unsigned int h, unsigned int argb);
extern int
vo_draw_rect_yuv420p (int channel, void *data, int src_w, int src_h,
                      unsigned int format, int x, int y,
                      unsigned int w, unsigned int h, unsigned int argb);

#if 0
/* ===================== vo_osd functions ================ */
#define VO_OSD_STYLE_NORMAL        0x00
#define VO_OSD_STYLE_BOLD          0x01
#define VO_OSD_STYLE_ITALIC        0x02
#define VO_OSD_STYLE_UNDERLINE     0x04

typedef void *FontHandle;
typedef void *TextHandle;

extern int
vo_osd_init ();

extern void
vo_osd_clean ();

extern FontHandle
vo_osd_open_font (const char *font, int ptsize, int renderstyle);

extern void
vo_osd_close_font (FontHandle hFont);

extern TextHandle
vo_osd_create_text (FontHandle hFont, const char *str, unsigned int fcolor, unsigned int bcolor);

extern int
vo_osd_show_text (TextHandle hText, Display_Rect *rect, unsigned int bcolor);

extern void
vo_osd_free_text (TextHandle hText);
#endif

#endif /* VO_SDL_H */
