#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "lib.h"

static void show_usage (int argc, char *argv[])
{
    printf ("Usage: %s <device_name>\n", argv[0]);
    printf ("  device_name                /dev/video[0~7]\n");
}

int main (int argc, char *argv[])
{
    const char *device_name;
    int fd, rc;
    int card_num;

    if (argc != 2) {
        show_usage (argc, argv);
        return -1;
    }

    device_name = argv[1];
    fd = open (device_name, O_RDWR | O_SYNC);
    if (fd < 0) {
        printf ("Cannot open device %s\n", device_name);
        show_usage (argc, argv);
        return -1;
    }

    rc = g_ctrl_CARDNUM (fd, &card_num);
    printf ("g_ctrl_CARDNUM %s: card_num = %d\n",
            rc ? "failed" : "succeeded", card_num);

    close (fd);
    return 0;
}
