#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include "lib.h"

static void show_usage (int argc, char *argv[])
{
    printf ("Usage: %s <device_name>\n", argv[0]);
    printf ("  device_name                /dev/video[0~7]\n");
}

int main (int argc, char *argv[])
{
    const char *device_name;
    int fd, rc;
    struct tm T;
    time_t t;

    if (argc != 2) {
        show_usage (argc, argv);
        return -1;
    }

    device_name = argv[1];
    fd = open (device_name, O_RDWR | O_SYNC);
    if (fd < 0) {
        printf ("Cannot open device %s\n", device_name);
        show_usage (argc, argv);
        return -1;
    }

    /* Set time: 2010-11-25 17:07:25 */
    T.tm_year = 2010 - 1900;
    T.tm_mon = 11 - 1;
    T.tm_mday = 25;
    T.tm_hour = 17;
    T.tm_min = 7;
    T.tm_sec = 25;
    t = mktime (&T);

    rc = s_ctrl_TIMESET (fd, (int)t);
    printf ("s_ctrl_TIMESET %s\n", rc ? "failed" : "succeeded");

    close (fd);
    return 0;
}
