#ifndef _PACDMP_REGS_H_
#define _PACDMP_REGS_H_

#define PACDMP_EVB_DDR               	    0x00000000  // ~ 0x07FFFFFF, 128MB SDRAM
#define PACDMP_EVB_SDRAM                    0x10000000	// ~ 0x11FFFFFF,  32MB SDRAM
#define PACDMP_EVB_ASRAM                    0x18000000  // ~ 0x181FFFFF,   8MB ASRAM
#define PACDMP_EVB_ESRAM                    0x1C000000  // ~ 0x1C007FFF,  32KB Block RAM0
#define PACDMP_EVB_PCI_MASTER               0x1D000000  // ~ 0x1DFFFFFF,  16MB PCI master memory region
#define PACDMP_EVB_DSP                      0x1E000000  // ~ 0x1E0FFFFF, PAC DSP
#define PACDMP_EVB_HPIPCI_CFG               0x1E100000	// ~ 0x1E10FFFF, PCI/HPI configuration space
#define PACDMP_EVB_SYSDMA                   0x1E110000	// ~ 0x1E11FFFF, System DMA controller
#define PACDMP_EVB_DSP_VIC1                 0x1E120000  // ~ 0x1E12FFFF, DSP VIC Lv1
#define PACDMP_EVB_DSP_VIC2                 0x1E121000  // ~ 0x1E121FFF, DSP VIC Lv2
#define PACDMP_EVB_HST_VIC1                 0x1E122000  // ~ 0x1E122FFF, Host VIC Lv1
#define PACDMP_EVB_HST_VIC2                 0x1E123000  // ~ 0x1E123FFF, Host VIC Lv2
#define PACDMP_EVB_VPU                      0x1E130000	// ~ 0x1E13FFFF, Video Processing Unit (video interface, osd, scaling)
#define PACDMP_EVB_AUDIO                    0x1E140000	// ~ 0x1E14FFFF, Audio interface
#define PACDMP_EVB_AEMIF_CFG                0x1E150000	// ~ 0x1E15FFFF, Asynchronous external memory interface
#define PACDMP_EVB_DDR_CFG1                 0x1E160000	// ~ 0x1E160FFF, DDR SDRAM config 1
#define PACDMP_EVB_DDR_CFG2                 0x1E161000	// ~ 0x1E161FFF, DDR SDRAM config 2
#define PACDMP_EVB_SYS_CFG                  0x1E162000	// ~ 0x1E162FFF, EVB system configuration (including PLL)
#define PACDMP_EVB_UART                     0x1E163000	// ~ 0x1E163FFF, UART
#define PACDMP_EVB_I2C                      0x1E164000	// ~ 0x1E164FFF, I2C
#define PACDMP_EVB_SPI                      0x1E165000	// ~ 0x1E165FFF, SPI
#define PACDMP_EVB_GPIO                     0x1E166000	// ~ 0x1E166FFF, GPIO
#define PACDMP_EVB_WATCHDOG                 0x1E167000	// ~ 0x1E167FFF, Watchdog
#define PACDMP_EVB_TIMER0                   0x1E168000	// ~ 0x1E168FFF, Timer 0
#define PACDMP_EVB_TIMER1                   0x1E169000	// ~ 0x1E169FFF, Timer 1
#define PACDMP_EVB_TIMER2                   0x1E16A000	// ~ 0x1E16AFFF, Timer 2
#define PACDMP_EVB_TIMER3                   0x1E16B000	// ~ 0x1E16BFFF, Timer 3
#define PACDMP_EVB_TIMER4                   0x1E16C000	// ~ 0x1E16CFFF, Timer 4
#define PACDMP_EVB_TIMER5                   0x1E16D000	// ~ 0x1E16DFFF, Timer 5
#define PACDMP_EVB_NFLASH                   0x1F000000	// ~ 0x1F1FFFFF, 2MB NOR Flash


// for backward compatibility only !!
#define PACDMP_EVB_SDRAM_BAR                PACDMP_EVB_DDR
#define PACDMP_EVB_BRAM_BAR0                PACDMP_EVB_ESRAM	
#define PACDMP_EVB_DSP_BAR                  PACDMP_EVB_DSP


/***********************************************************\
 * Included files for detail register definition
\***********************************************************/
#include "pacdmp_dsp_regs.h"			// DSP core
#include "pacdmp_vic_regs.h"			// VIC
#include "pacdmp_sysdma_regs.h"			// System DMA

#endif /* #ifndef _PACDMP_PCI_H_ */
