#ifndef _PACDMP_TYPES_H_
#define _PACDMP_TYPES_H_


#define u8      unsigned char
#define u16     unsigned short
#define u32     unsigned int

#define PACDMP_MMIO_SIZE  0x1000000 // 16MB


typedef enum pacdmp_ioctl_cmd_type_e
{
  PACDMP_CTL_SET_WINDOW_BASE = 1,
  PACDMP_CTL_READ_REG32,
  PACDMP_CTL_WRITE_REG32,
  PACDMP_CTL_READ_REG16,
  PACDMP_CTL_WRITE_REG16,
  PACDMP_CTL_READ_REG8,
  PACDMP_CTL_WRITE_REG8,
  PACDMP_CTL_GET_PHYBAR,
  PACDMP_CTL_GET_ISRFLG,
} PACDMP_IOCTL_CMD_TYPE;

typedef struct pacdmp_reg32_t
{
  unsigned int value;
  unsigned int base; // unit: byte
  unsigned int offset;

} REG32;

typedef struct pacdmp_reg16_t
{
  unsigned short value;
  unsigned int base;
  unsigned int offset;
} REG16;

typedef struct pacdmp_reg8_t
{
  unsigned char value;
  unsigned int base;
  unsigned int offset;
} REG8;

typedef enum pacdmp_rw_cmd_type_e
{
  RW_IOCTL = 1,
  RW_MEMCPY
} PACDMP_RW_CMD_TYPE;

typedef enum pacdmp_boot_dsp_mode_e
{
  BOOT_DIRECT = 0x3064,
  BOOT_ICACHE_DONE = 0x3068
} PACDMP_BOOT_MODE;

#endif /* _PACDMP_TYPES_H_ */
