/********************************************\
cci.h:
	DSP communication with HOST via PCI
\********************************************/
#ifndef _SPCT6100_CCI_H_
#define _SPCT6100_CCI_H_


#if !defined(_WIN32)
	typedef unsigned int 	Uint32;
	typedef unsigned short 	Uint16;
	typedef unsigned char 	Uint8;
#endif

#include "cci.h"

typedef struct tag_SCPT6100_CCI_CHAN_SET
{
  Uint32	uChanID;
  Uint32	uStatus;
  Uint32	uMode;					//byte0: video mode(PAL/NTSC)
  Uint32 	uReserved;
  Uint32  LivePathBufBAR;         // livePath RingBuffer Base Address
  Uint32  LivePathFrameSize;      // livePath RingBuffer Frame Size
  Uint32  LivePathScale;          // 0: not scale ,1: scale 1/2 ,2:scale 1/4
  Uint32	uVideoPitch[2];	
  CCI_CHAN_PARAM	tParam;
} SPCT6100_CCI_CHAN_SET, *PSPCT6100_CCI_CHAN_SET;


/* dsp need to define where to put spct6100_cci_env */
//#define	SPCT6100_ENV_ADDR	0x07b00000 /* as jlluo's ddr memory layout */
//gordon
#define	SPCT6100_ENV_ADDR	0x1e003c00 
//#define	SPCT6100_ENV_ADDR	0x07b00000 
#define	SPCT6100_ENV_DSP2HOST_UFLAG_ADDR	(SPCT6100_ENV_ADDR + 0x18 + 0x04)
#define	SPCT6100_ENV_ENCODEPATHFLIP0_ADDR	(SPCT6100_ENV_ADDR+0x1fc)
#define	SPCT6100_ENV_ENCODEPATHFLIP1_ADDR	(SPCT6100_ENV_ADDR+0x1fe)
#define	SPCT6100_DSP2HOST_ADDR ((Uint32)(&((PSPCT6100_ENV)SPCT6100_ENV_ADDR)->dsp2host))	
#define	SPCT6100_BAR3_BASE 0x1e000000
#define SPCT6100_CCI_DSP2HOST_DATABUF_LEN (256*1024) // jonathan 2008.08.07

typedef struct tag_SPCT6100_ENV
{
  Uint32		uMagicID;
  Uint32		uDevID;
  //31~24: reserved
  //23~16: language id
  //15~8:  odm id
  //7~0:   odm ext id
  Uint32		uOutputSet;	
  //31~16:	watchdog
  //15~0:	output value
  //Uint32	uReserved;
  Uint8			uDisplayMode;
  Uint8			uReserved0;
  Uint8			uReserved1;
  Uint8			uReserved2;
  
  Uint32		uDataBuf[2];        //EncodedPath uDataBuf[0] = Ping Buffer Base Address, uDataBuf[1] = Pong Buffer Base Address.
  
  CCI_DSP2HOST	        dsp2host;
  
  SPCT6100_CCI_CHAN_SET	chanSet[4]; /* distinguish the original cci_env : cci_chan_set */
  CCI_EEROM_PARAM	eerom_param;	
  Uint8			bTime[8];
  Uint32		dwIcon[4];
  Uint16		wAudioMask[4];
  Uint32                HostEndian ;         // 0:Little-endian ,1:Big-endian
  Uint16                EncodedPathPPFlag[2];   
  // 0x????0000: Ping is available ,0x????0001: Ping is not available
  // 0x0000????: Pong is available ,0x0001????: Pong is not available 
  
} SPCT6100_ENV, *PSPCT6100_ENV;


#endif //_SPCT6100_CCI_H_
