// SPCT6100ioctl.h
//
// Define control codes for SPCT6100 driver
//

#ifndef __SPCT6100ioctl__h_
#define __SPCT6100ioctl__h_

#define SPCT6100_IOCTL_TEST CTL_CODE(FILE_DEVICE_UNKNOWN, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define SPCT6100_IOCTL_SDRAMWRITE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x801, METHOD_IN_DIRECT, FILE_ANY_ACCESS)

#define SPCT6100_DRIVER_VERSION 0x00010001

#define SPCT6100_SUCCESS        0
#define SPCT6100_FAIL           1

#define INVALID_BUFUSE  0xff000000

// jonathan 2008.08.11
#define SPCT6100_DSPREG_MINADDR 0x1E000000
#define SPCT6100_DSPREG_MAXADDR (SPCT6100_DSPREG_MINADDR + 0x00FFFFFF)

// jonathan 2008.08.07
typedef enum e_SPCT6100_CMDTYPE
{
    SPCT6100_DSPIO = 0,
    SPCT6100_DSPREG,
    SPCT6100_DSPMEM,
    SPCT6100_PCMEM,
    SPCT6100_VIDEOMEM,
    SPCT6100_WAITINT,
    SPCT6100_GETCOMMBUF,
    SPCT6100_GETVPERESOLUTION,
    SPCT6100_VPU_LIVESCALE,
    SPCT6100_OSD_CLOCK,

    SPCT6100_LOCKMEM,
    SPCT6100_UNLOCKMEM,
    SPCT6100_GETICSTATUS,
    SPCT6100_SETVPETHRESHOLD,
    SPCT6100_PCIBAR3,

    SPCT6100_GET_DRVVERSION =       100
} SPCT6100_CMDTYPE;

typedef struct tag_SPCT6100_LIVE_HEADER
{
  ULONG uChanID;
  ULONG uFlag;
}SPCT6100_LIVE_HEADER,*PSPCT6100_LIVE_HEADER;

typedef struct tag_SPCT6100_CMDHDR
{
  ULONG   uTotalSize;                 //BYTE
  ULONG   uType;
  union
  {
    ULONG   uHandle;
    ULONG   uDrvVersion;
    ULONG   uIcStatus;
  };
  ULONG   uPhysicalAddress;
  ULONG   uVirtualAddress;
  ULONG   uReqSize;                   //DWORD
  ULONG   uStatus;
}SPCT6100_CMDHDR, *PSPCT6100_CMDHDR;

typedef struct tag_HOST2DSP_PAC_PIPE
{
  ULONG   uDSPAddress;                //DSP base address
  ULONG   uVideoAddress;
  ULONG   uDataAddress;
  ULONG   uPitch; 
}HOST2DSP_PAC_PIPE, *PHOST2DSP_PAC_PIPE;

typedef struct tag_DSP2HOST_PAC_MSG
{
  ULONG   uChanID;
  ULONG   uPingpong;
  ULONG   uShowSize;
  ULONG   uDataAddress;
  ULONG   uDataLen;
}DSP2HOST_PAC_MSG, *PDSP2HOST_PAC_MSG;

// jonathan 2008.08.07
typedef enum e_SPCT_DSP_MODE
{
    SPCT_DSP_TRAPPED   = 0x0,
    SPCT_DSP_RUNNING   = 0x1,
    SPCT_DSP_EXCEPTION = 0x2,
    SPCT_DSP_DEBUGGING = 0x4
} SPCT_DSP_MODE;

#endif // __SPCT6100ioctl__h_
