#ifndef SPCT6100_TRACE_H
#define SPCT6100_TRACE_H

/*
#define KERN_EMERG      "<0>"
#define KERN_ALERT      "<1>"
#define KERN_CRIT       "<2>"
#define KERN_ERR        "<3>"
#define KERN_WARNING    "<4>"
#define KERN_NOTICE     "<5>"
#define KERN_INFO       "<6>"
#define KERN_DEBUG      "<7>"
*/
enum TraceLevel {
    LEVEL_ERROR = 3,
    LEVEL_WARNING = 4,
    LEVEL_INFO = 6,
    LEVEL_DEBUG = 7
};

extern int spct6100_trace;

#define spct6100_printk(level, fmt, args...) \
    do { \
        if (spct6100_trace >= level) { \
            printk (fmt, ## args); \
        } \
    } while (0)

#define ERROR(fmt, args...) \
    do { \
        if (spct6100_trace >= LEVEL_ERROR) { \
            printk (KERN_ERR fmt, ## args); \
        } \
    } while (0)

#define WARNING(fmt, args...) \
    do { \
        if (spct6100_trace >= LEVEL_WARNING) { \
            printk (KERN_WARNING fmt, ## args); \
        } \
    } while (0)

#define INFO(fmt, args...) \
    do { \
        if (spct6100_trace >= LEVEL_INFO) { \
            printk (KERN_INFO fmt, ## args); \
        } \
    } while (0)

#define DEBUG(fmt, args...) \
    do { \
        if (spct6100_trace >= LEVEL_DEBUG) { \
            printk (KERN_DEBUG fmt, ## args); \
        } \
    } while (0)

#endif /* SPCT6100_TRACE_H */
