#ifndef SPCT6100_UTILS_H
#define SPCT6100_UTILS_H

#define SPCT6100_DEFAULT_MODE         1
#define SPCT6100_DEFAULT_LSHOWSIZE    1
#define SPCT6100_DEFAULT_CSHOWSIZE    1
#define SPCT6100_DEFAULT_ENCODESPEED  30
#ifdef __arm__
#define SPCT6100_DEFAULT_STATUS       1
#else
#define SPCT6100_DEFAULT_STATUS       3
#endif

///EXPOSE
#define V4L2_CID_REQIFRAME            (V4L2_CID_PRIVATE_BASE + 0)
///ENDEXPOSE
#define V4L2_CID_INITENV              (V4L2_CID_PRIVATE_BASE + 1)

///EXPOSE
//v4l2 has defined these four
//use them directly
//#define V4L2_CID_BRIGHTNESS
//#define V4L2_CID_CONTRAST
//#define V4L2_CID_SATURATION
//#define V4L2_CID_HUE
///ENDEXPOSE

#define V4L2_CID_MODE                 (V4L2_CID_PRIVATE_BASE + 6)
///EXPOSE
#define V4L2_CID_STATUS               (V4L2_CID_PRIVATE_BASE + 7)
///ENDEXPOSE
#define V4L2_CID_FLAG                 (V4L2_CID_PRIVATE_BASE + 8)
///EXPOSE
#define V4L2_CID_EQUALITY             (V4L2_CID_PRIVATE_BASE + 9)
#define V4L2_CID_LSHOWSIZE            (V4L2_CID_PRIVATE_BASE + 10)
#define V4L2_CID_EENSPEED             (V4L2_CID_PRIVATE_BASE + 11)
///ENDEXPOSE
#define V4L2_CID_LFRAMESIZE           (V4L2_CID_PRIVATE_BASE + 12)
#define V4L2_CID_LBUFBAR              (V4L2_CID_PRIVATE_BASE + 13)
#define V4L2_CID_LPATHSCALE           (V4L2_CID_PRIVATE_BASE + 14)
///EXPOSE
#define V4L2_CID_MOSAIC               (V4L2_CID_PRIVATE_BASE + 15)
#define V4L2_CID_MOTIONDETECT         (V4L2_CID_PRIVATE_BASE + 16)
///ENDEXPOSE
#define V4L2_CID_OSDTIMESYNC          (V4L2_CID_PRIVATE_BASE + 17)
#define V4L2_CID_DOWNLOAD             (V4L2_CID_PRIVATE_BASE + 18)
#define V4L2_CID_CARDNUM              (V4L2_CID_PRIVATE_BASE + 19)
#define V4L2_CID_DSPSTATUS            (V4L2_CID_PRIVATE_BASE + 20)
#define V4L2_CID_ALLMODE              (V4L2_CID_PRIVATE_BASE + 21)
#define V4L2_CID_UPLOAD               (V4L2_CID_PRIVATE_BASE + 22)
#define V4L2_CID_DISABLEMOSAIC        (V4L2_CID_PRIVATE_BASE + 23)
#define V4L2_CID_RUNCODE              (V4L2_CID_PRIVATE_BASE + 24)
#define V4L2_CID_STOPBOARD            (V4L2_CID_PRIVATE_BASE + 25)
#define V4L2_CID_TIMEOUT              (V4L2_CID_PRIVATE_BASE + 26)
///EXPOSE
#define V4L2_CID_MINTERVAL            (V4L2_CID_PRIVATE_BASE + 27)
#define V4L2_CID_MTHRESHOLD           (V4L2_CID_PRIVATE_BASE + 28)
///ENDEXPOSE
#define V4L2_CID_DROPFRAME            (V4L2_CID_PRIVATE_BASE + 29)
#define V4L2_CID_DSPPING              (V4L2_CID_PRIVATE_BASE + 30)
///EXPOSE
#define V4L2_CID_WI2C                 (V4L2_CID_PRIVATE_BASE + 31)
#define V4L2_CID_RI2C                 (V4L2_CID_PRIVATE_BASE + 32)
#define V4L2_CID_GPIOD                (V4L2_CID_PRIVATE_BASE + 33)
#define V4L2_CID_WGPIO                (V4L2_CID_PRIVATE_BASE + 34)
#define V4L2_CID_VLOSTEN              (V4L2_CID_PRIVATE_BASE + 35)
#define V4L2_CID_OSDSET               (V4L2_CID_PRIVATE_BASE + 36)
#define V4L2_CID_GOPSET               (V4L2_CID_PRIVATE_BASE + 37)
#define V4L2_CID_REQISEQ              (V4L2_CID_PRIVATE_BASE + 38)
#define V4L2_CID_GETCLR               (V4L2_CID_PRIVATE_BASE + 39)
#define V4L2_CID_RGPIO                (V4L2_CID_PRIVATE_BASE + 40)
#define V4L2_CID_WATCHEN              (V4L2_CID_PRIVATE_BASE + 41)
#define V4L2_CID_WATCHSET             (V4L2_CID_PRIVATE_BASE + 42)
#define V4L2_CID_CSHOWSIZE            (V4L2_CID_PRIVATE_BASE + 43)
#define V4L2_CID_PREVIEW              (V4L2_CID_PRIVATE_BASE + 44)
#define V4L2_CID_AUDIO                (V4L2_CID_PRIVATE_BASE + 45)
#define V4L2_CID_TIMESET              (V4L2_CID_PRIVATE_BASE + 46)
#define V4L2_CID_CROPSET              (V4L2_CID_PRIVATE_BASE + 47)
///ENDEXPOSE
#define NUM_V4L2_CID                  (48)
#define V4L2_CID_PRIVATE_LASTP1       (V4L2_CID_PRIVATE_BASE + NUM_V4L2_CID)

#define BRIGHT_INDEX       2//(V4L2_CID_BRIGHTNESS - V4L2_CID_PRIVATE_BASE)
#define CONTRAST_INDEX     3//(V4L2_CID_CONTRAST   - V4L2_CID_PRIVATE_BASE)
#define SATURATION_INDEX   4//(V4L2_CID_SATURATION - V4L2_CID_PRIVATE_BASE)
#define HUE_INDEX          5//(V4L2_CID_HUE        - V4L2_CID_PRIVATE_BASE)
#define MODE_INDEX         (V4L2_CID_MODE         - V4L2_CID_PRIVATE_BASE)
#define STATUS_INDEX       (V4L2_CID_STATUS       - V4L2_CID_PRIVATE_BASE)
#define FLAG_INDEX         (V4L2_CID_FLAG         - V4L2_CID_PRIVATE_BASE)
#define EQUALITY_INDEX     (V4L2_CID_EQUALITY     - V4L2_CID_PRIVATE_BASE)
#define LSHOWSIZE_INDEX    (V4L2_CID_LSHOWSIZE    - V4L2_CID_PRIVATE_BASE)
#define EENSPEED_INDEX     (V4L2_CID_EENSPEED     - V4L2_CID_PRIVATE_BASE)
#define LFRAMESIZE_INDEX   (V4L2_CID_LFRAMESIZE   - V4L2_CID_PRIVATE_BASE)
#define LBUFBAR_INDEX      (V4L2_CID_LBUFBAR      - V4L2_CID_PRIVATE_BASE)
#define LPATHSCALE_INDEX   (V4L2_CID_LPATHSCALE   - V4L2_CID_PRIVATE_BASE)
#define MINTERVAL_INDEX    (V4L2_CID_MINTERVAL    - V4L2_CID_PRIVATE_BASE)
#define MTHRESHOLD_INDEX   (V4L2_CID_MTHRESHOLD   - V4L2_CID_PRIVATE_BASE)
#define DROPFRAME_INDEX    (V4L2_CID_DROPFRAME    - V4L2_CID_PRIVATE_BASE)
#define DSPPING_INDEX      (V4L2_CID_DSPPING      - V4L2_CID_PRIVATE_BASE)
#define VLOSTEN_INDEX      (V4L2_CID_VLOSTEN      - V4L2_CID_PRIVATE_BASE)
#define MOTION_INDEX       (V4L2_CID_MOTIONDETECT - V4L2_CID_PRIVATE_BASE)
#define CSHOWSIZE_INDEX    (V4L2_CID_CSHOWSIZE    - V4L2_CID_PRIVATE_BASE)
#define PREVIEW_INDEX      (V4L2_CID_PREVIEW      - V4L2_CID_PRIVATE_BASE)
#define AUDIO_INDEX        (V4L2_CID_AUDIO        - V4L2_CID_PRIVATE_BASE)
#define TIMESET_INDEX      (V4L2_CID_TIMESET      - V4L2_CID_PRIVATE_BASE)

///EXPOSE
// buffer type flag
#define V4L2_BUF_FLAG_SPCT6100_SPS     0x01
#define V4L2_BUF_FLAG_SPCT6100_AUDIO   0x02
#define V4L2_BUF_FLAG_SPCT6100_MOTION  0x04
#define V4L2_BUF_FLAG_SPCT6100_VLOST   0x10
#define V4L2_BUF_FLAG_SPCT6100_VIDEO   0x20
///ENDEXPOSE

enum packet_id;

enum spct6100_reg_index {
  REG_UMODE,
  REG_UCOLOR,
  REG_UFLAGS,
  REG_USTATUS,
  REG_UQUALITY,
  REG_USHOWSIZE,
  REG_UENCODERSPEED,
  REG_ULPFS,
  REG_ULPBB,
  REG_ULPS,
  REG_UMOSAIC,
  REG_UMOTIONPARAM,
  REG_UMASKAREA,

  REG_L_RING,
  REG_C_FLAGS,
  REG_C_CHANID,

  REG_STAT_VIC1,
  REG_STAT_VIC2,
  REG_CLEAR_VIC1,
  REG_CLEAR_VIC2,

  REG_BUFPTR,
  REG_BUFUSG,
  REG_FLIP,

  REG_OSD_WINDOW0_COLOR,
  REG_OSD_WINDOW1_COLOR,
  REG_OSD_WINDOW1_SIZE,
  REG_OSD_WINDOW1_POSITION,
  REG_OSD_WINDOW1_FONT,
  REG_OSD_ENABLE_CONTROL,
  REG_OSD_YMD_INT,
  REG_OSD_YMD_SETTING_REG,
  REG_OSD_YMD_SETTING_MODE,
  REG_OSD_HMS_INT,
  REG_OSD_HMS_SETTING_REG,
  REG_OSD_HMS_READBLOCK_COUNTER,
  REG_OSD_TIMER_ADJUSTMENT_REG,
  REG_OSD_TIMER_CHANGE,

  REG_DSP_CBUSY,
  REG_DSP_ICFLUSH,
  REG_DSP_ICSA,
  REG_DSP_ICPS,
  REG_DSP_CPSA,
  REG_DSP_CPS,
  REG_DSP_ICS,
  REG_DSP_ICDONE,

  REG_STOPBOARD_STEP1,
  REG_STOPBOARD_STEP2,
  REG_STOPBOARD_STEP3,
  REG_STOPBOARD_STEP4,
  REG_STOPBOARD_STEP5,
  REG_STOPBOARD_STEP6,

  REG_INT_VIC1_ENABLE,
  REG_INT_VIC2_ENABLE,

  REG_AV_RESERVED0,
  REG_AV_FLAGS,
  REG_AV_TOTALSIZE,
  REG_AV_AUDIOOFF,
  REG_AV_AUDIOLEN,
  REG_AV_VIDEOOFF,
  REG_AV_VIDEOLEN,
  REG_AV_MASKSTATE0,
  REG_AV_MASKSTATE1,
  REG_AV_MASKSTATE2,
  REG_AV_MASKSTATE3,
  REG_AV_MASKSTATE4,

  REG_VPE_DPE,
  REG_VPE_LIVEBASE,
  REG_VPE_FTHRESHOLD,
  REG_VPE_LTHRESHOLD,
  REG_VPE_CTHRESHOLD,
  REG_VPE_GTHRESHOLD,
  REG_VPE_DTHRESHOLD,

  REG_ENV_V,
  REG_DSP2HOST_V,

  REG_CQ_BASE,
  REG_CQ_PKTNUM,
  REG_CQ_PKTLEN,
  REG_DQ_BASE,
  REG_DQ_PKTNUM,
  REG_DQ_PKTLEN,
  REG_FIRMWARE_STATUS,
  REG_NUM,
};

void
spct6100_calculate_year_month_day(time_t input_time,
                                  unsigned int *arg_year,
                                  unsigned int *arg_month,
                                  unsigned int *arg_day,
                                  unsigned int *arg_hour,
                                  unsigned int *arg_minute,
                                  unsigned int *arg_second);

void
spct6100_osd_str(char *dst, const char *src);

void
spct6100_enabledevice(void *dev, unsigned int addr);

int
spct6100_stop_board(void *dev);

void
spct6100_dropframe(void *dev);

void
init_queue_table(void *dev);

int
spct6100_dvr_probe_common(void *dev);

void
spct6100_dvr_free_resources(void *dev);

void
spct6100_set_reg(void *cur_dev,
                 enum spct6100_reg_index index,
                 unsigned char *data,
                 int channel_id,
                 ...);
void
spct6100_get_reg(void *cur_dev,
                 enum spct6100_reg_index index,
                 unsigned char *data,
                 int channel_id);
void
spct6100_initenv(void *cur_dev, int compress_only, int compress_quality, int support_tvtime);

int
remove_cmd_node(unsigned short serialnum, enum packet_id *ackid, int *ackchannel);

void
insert_cmd_node(void *dev, enum packet_id id,
                int payloadsize,
                int channel_id, unsigned char *data,
                void *old_value);

int
pid_external_to_local(int input);

int
pid_local_to_external(int input);

void
spct6100_init_cmd(void *file, void *dev);

#define DPACKET_LEN (704*576*2+4*1024)
#define DPACKET_NUM 4
#define CPACKET_LEN 128
#define CPACKET_NUM 512
#define CPACKET_DEFAULT_QBASE 0xFFFFFFFF
#define QUEUE_TABLE_SIZE (4*1024)

#define CPACKET_P(x) ((struct pheader *)(x)
#define CPACKET_OWNER(x) (((struct pheader *)(x))->owner)
#define CPACKET_ID(x) (((struct pheader *)(x))->id)
#define CPACKET_SERIAL(x) (((struct pheader *)(x))->serialnum)
#define CPACKET_FLAG(x) (((struct pheader *)(x))->flag)
#define CPACKET_COMMON(x) (((struct pheader *)(x))->common)
#define CPACKET_RESERVED(x) (((struct pheader *)(x))->reserved)
#define CPACKET_PAYLOADSIZE(x) (((struct pheader *)(x))->payloadsize)

#define DPACKET_P(x) ((struct pheader *)(x))
#define DPACKET_OWNER(x) (((struct pheader *)(x))->owner)
#define DPACKET_ID(x) (((struct pheader *)(x))->id)
#define DPACKET_SERIAL(x) (((struct pheader *)(x))->serialnum)
#define DPACKET_FLAG(x) (((struct pheader *)(x))->flag)
#define DPACKET_COMMON(x) (((struct pheader *)(x))->common)
#define DPACKET_RESERVED(x) (((struct pheader *)(x))->reserved)
#define DPACKET_PAYLOADSIZE(x) (((struct pheader *)(x))->payloadsize)

struct queue_context {
  unsigned int dq_base;
  unsigned int dq_len;
  unsigned int dq_num;
  unsigned int cq_base;
  unsigned int cq_len;
  unsigned int cq_num;
  unsigned int cur_cq_pos;
  unsigned int cur_dq_pos;
  unsigned int cq_end;
  unsigned int dq_end;
  unsigned int status;
};

#define NR_COLOR 41
extern unsigned int osd_color_table[NR_COLOR];
#endif /* SPCT6100_UTILS_H */
