#ifndef LIB_H
#define LIB_H

#include "spct6100-v4l2-types.h"

// ==== S_STD/G_STD ====
// szStd: "PAL"/"pal", "NTSC"/"ntsc"
int s_std (int fd, const char *szStd);
int g_std (int fd, char *szStd);

// ==== S_INPUT/G_INPUT ====
// input: 0,1,2,3
int s_input (int fd, int input);
int g_input (int fd, int *input);

// ==== S_FMT/G_FMT ====
int s_fmt (int fd, int width, int height, const char *szFmt);
int g_fmt (int fd, int *width, int *height, char *szFmt);

// ==== STREAMON/STREAMOFF ====
int stream_on (int fd);
int stream_off (int fd);

// ==== S_CTRL/G_CTRL ====
int s_ctrl_MODE (int fd, int value);
int s_ctrl_STATUS (int fd, int value);
int s_ctrl_EENSPEED (int fd, int value);
int s_ctrl_BRIGHTNESS (int fd, int value);
int s_ctrl_CONTRAST (int fd, int value);
int s_ctrl_SATURATION (int fd, int value);
int s_ctrl_HUE (int fd, int value);
int s_ctrl_VLOSTEN (int fd, int value);
int s_ctrl_LSHOWSIZE (int fd, int value);
int s_ctrl_CSHOWSIZE (int fd, int value);
int s_ctrl_MOTIONDETECT (int fd, int value);
int s_ctrl_MTHRESHOLD (int fd, int value);
int s_ctrl_MINTERVAL (int fd, int value);
int s_ctrl_PREVIEW (int fd, int value);
int s_ctrl_AUDIO (int fd, int value);
int s_ctrl_TIMEOUT (int fd, int value);
int s_ctrl_GOP (int fd, struct spct6100_gop *gop);
int s_ctrl_OSD (int fd, struct spct6100_osd *osd);
int s_ctrl_MOSAIC (int fd, struct spct6100_mosaic *mosaic);
int s_ctrl_EQUALITY (int fd, struct spct6100_equality *equality);
int s_ctrl_GPIOD (int fd, struct spct6100_gpio *gpio);

int s_ctrl_REQIFRAME (int fd, int value);
int s_ctrl_REQISEQ (int fd, int value);
int s_ctrl_TIMESET (int fd, int value);
int s_ctrl_CROPSET (int fd, struct spct6100_cropset *cropset);
int s_ctrl_WGPIO (int fd, struct spct6100_gpio *gpio);
int s_ctrl_RGPIO (int fd, struct spct6100_gpio *gpio);
int s_ctrl_DOWNLOAD (int fd, unsigned int dsp_addr, char *buf, int buf_size);
int s_ctrl_RUNCODE (int fd, unsigned int dsp_addr);
int s_ctrl_INITENV (int fd);
/*
int s_ctrl_WI2C (int fd, struct spct6100_eeprom *eeprom);
int s_ctrl_RI2C (int fd, struct spct6100_eeprom *eeprom);
*/

int g_ctrl_MODE (int fd, int *value);
int g_ctrl_STATUS (int fd, int *value);
int g_ctrl_EENSPEED (int fd, int *value);
int g_ctrl_BRIGHTNESS (int fd, int *value);
int g_ctrl_CONTRAST (int fd, int *value);
int g_ctrl_SATURATION (int fd, int *value);
int g_ctrl_HUE (int fd, int *value);
int g_ctrl_VLOSTEN (int fd, int *value);
int g_ctrl_LSHOWSIZE (int fd, int *value);
int g_ctrl_CSHOWSIZE (int fd, int *value);
int g_ctrl_MOTIONDETECT (int fd, int *value);
int g_ctrl_MTHRESHOLD (int fd, int *value);
int g_ctrl_MINTERVAL (int fd, int *value);
int g_ctrl_PREVIEW (int fd, int *value);
int g_ctrl_AUDIO (int fd, int *value);
int g_ctrl_TIMEOUT (int fd, int *value);
int g_ctrl_GOP (int fd, struct spct6100_gop *gop);
int g_ctrl_OSD (int fd, struct spct6100_osd *osd);
int g_ctrl_MOSAIC (int fd, struct spct6100_mosaic *mosaic);
int g_ctrl_EQUALITY (int fd, struct spct6100_equality *equality);
int g_ctrl_GPIOD (int fd, struct spct6100_gpio *gpio);

int g_ctrl_CARDNUM (int fd, int *value);
int g_ctrl_DSPSTATUS (int fd, int *value);
int g_ctrl_UPLOAD (int fd, unsigned int dsp_addr, char *buf, int buf_size);

#endif /* LIB_H */
